﻿using System;
using System.Runtime.CompilerServices;

class Program
{
    static void Main(string[] args)
    {
        LocalsInitMethod();

        Console.WriteLine();
        NonLocalsInitMethod();

        Console.WriteLine();
        LocalsInitStackAlloc();

        Console.WriteLine();
        NonLocalsInitStackAlloc();
    }

    private static unsafe void LocalsInitStackAlloc()
    {
        int *intArray = stackalloc int[100];
    }

    [SkipLocalsInitAttribute]
    private static void NonLocalsInitStackAlloc()
    {
        Span<int> intArray = stackalloc int[100];
    }

    private static /* unsafe */ void LocalsInitMethod()
    {
        int i;
        int j;

        /*
        int* pi = &i;
        int* pj = &j;

        Console.WriteLine(*pi);
        Console.WriteLine(*pj);
        */
    }

    [SkipLocalsInitAttribute]
    private static /* unsafe */ void NonLocalsInitMethod()
    {
        int i;
        int j;

        /*
        int* pi = &i;
        int* pj = &j;

        Console.WriteLine(*pi);
        Console.WriteLine(*pj);
        */
    }
}

#if !NET5_0
namespace System.Runtime.CompilerServices
{
    [AttributeUsage(AttributeTargets.Module | AttributeTargets.Class | AttributeTargets.Struct | AttributeTargets.Constructor | AttributeTargets.Method | AttributeTargets.Property | AttributeTargets.Event | AttributeTargets.Interface, Inherited = false)]
    public sealed class SkipLocalsInitAttribute : Attribute
    {
    }
}
#endif